#ifndef _LIB_INI_H_
#define _LIB_INI_H_

#include <stdbool.h>
#include <pspiofilemgr.h>

#ifdef __cplusplus
extern "C" {
#endif



/*
	iniLoad/iniSave/iniSplitɂ
	ĂKey/Value͓ǂݍ񂾂܂܂̏ԂȂ̂
	R[obN֐ŏۂ͑啶/̋ʂ
	ǂ邩ӎ̂YȂŉ
	
	啶/ʂF悤ɂ̂ʓI
*/



//iniAddKeyŎw肷Keỹf[^^
typedef enum
{
	INI_TYPE_NONE = 0,	//
	INI_TYPE_DEC,		//10i
	INI_TYPE_HEX,		//16i
	INI_TYPE_OCT,		//8i
	INI_TYPE_BOOL,		//BOOL
	INI_TYPE_STR,		//
	
	//DEC/OCT/HEXiniLoad/iniSaveŒl𐳂擾/ۑׂɎw
}ini_type;


//Key,ValuẽyA
typedef struct
{
	ini_type	type;	//f[^^Cv
	const char	*key;	//Key
	
	void *val_p;
	int val_def;
	bool flag;
} ini_pair;


//iniParseLine
typedef struct
{
	char *key;			//key
	char *key_end;		//key̍Ō
	char key_end_cd;	//key_end̕
	
	char *val;			//value
	char *val_end;		//value̍Ō
	char val_end_cd;	//value_end̕
	
	//key_endAval_endiniParseLine
	//̏Ԃ֖߂ׂɗpӂĂ
} ini_line;



typedef struct
{
	ini_pair *pair;		//Key/Valueǉ/ݒ/폜ۂɎgpini_pairz
	int size;			//pairŎw肵zTCY( sizeof(pair) )
	
	char *buf;			//iniReadLine/iniSplitValŎgobt@[w
	int bufLen;			//buf̃TCYiŎw肵liniReadLineœǂݍ߂1s̍ő啶j
} ini_data;



typedef void (*libini_cbsp)(const char *val,void *callback_opt);
typedef const char* (*libini_cbs)(const char *key,void *opt);
typedef bool (*libini_cbl)(const char *key, char *val,void *opt);


enum
{
	INIREADLINE_END		= 0,
	INIREADLINE_CR		= -1,
	INIREADLINE_LF		= -2,
	INIREADLINE_CRLF	= -3,
};



/*	iniReadLine
    t@C1sǂݍ
    
    @param: SceUID fd
    SceIoOpenŊJt@C
    
    @param: char *buf
    ǂݍ񂾕i[obt@[
    
    @param: int bufLen
    obt@[TCY
	TCY1sۂƎ擾oȂ̂ŕKvɉĎw
    
    @return: ȉ̒ʂ
	
	INIREADLINE_END		= t@CI[		buf -> '\0'̂
    INIREADLINE_CR		= sR[h(CR) 	buf -> '\0'̂
    INIREADLINE_LF		= sR[h(LF)	buf -> '\0'̂
    INIREADLINE_CRLF	= sR[h(CRLF)	buf -> '\0'̂
	ȊO			= ǂݍ񂾕	buf -> ǂݍ񂾕
 */
int iniReadLine( SceUID fd, char *buf, int bufLen );

/*	iniParseLine
    iniReadLineɂēǂݍ񂾕KeyAValue֕
    
    @param: ini_line *line
    ʂ󂯎 ini_lineϐ
    
    @param: void *buf
    Ώە
	
    @return: true = Afalse = s(Key = Valuě`ł͂Ȃ)
    
    Key/Value̎n܂/I
    @^u(\t)Ap/SpXy[XOʒuɂȂ܂
 */
bool iniParseLine( ini_line *line ,void *buf );


/*	iniSplitVal
    iniParseLine瓾Valueijؕŕ
    
    @param: char *val
    Ώە
    
    @param: const char *delim
    ؂蕶
    
    @param: libini_cbsp callback_sp
    ؂ꂽ󂯎R[obN֐
	
	[R[obN֐֑Ăl]
    val 			= ؂ꂽ
    callback_opt	= iniSplitValŎw肵f[^iCӁj
    
    @param: void *callback_opt
    R[obN֐֓nf[^
 */
void iniSplitVal( char *val ,const char *delim ,libini_cbsp callback_sp ,void *callback_opt );



/*	iniSearchKey
  	data(ini_data*) w肵Key܂܂f[^(ini_pair*)擾
    
    @param: ini_data *data
    Ώۂini_dataϐ
    
    @param: const char *key
    ΏۂKey
    NULLw肷Ƌ(KeyZbgĂȂꏊjT
	
    @return: ΏKey܂܂Ăf[^(ini_pair*)
    NULL = ݂Ȃ
 */
ini_pair* iniSearchKey( ini_data *data ,const char *key );

/*	iniAddKey
  	data(ini_data*)Key(Value)ǉ
    
    @param: ini_data *data
    Ώۂini_dataϐ
    
    @param: ini_data *data
    ǉΏۂKey
	
    @param: ini_type type
    f[^̃^CvwiINI_TYPE_NONEȊO)
    
    @param: void *val_p
    iniLoads鎞ɁA擾lۑϐ̃|C^[
    (^ł͂ȂAiniLoadȂꍇNULLwj
	
    void *ƂȂĂ܂Aint_typeɂĎw肷|C^[ϐ̌^܂Ă܂
    
    *bool = INI_TYPE_BOOL
    *int  = INI_TYPE_DEC / INI_TYPE_OCT / INI_TPYE_HEX
    
    
    @param: int val
    ǉKey֊֘Atl
    
    iniAddKeyiniLoad / iniSave邩Œl̈قȂ܂
    
    iniLoad => t@C擾sꍇ̃ftHgl
    iniSave => t@C֕ۑl
	
    @return: true = Afalse = siz̃TCYȂAɑ݂KeyAȃ^Cv)
 */
bool iniAddKey( ini_data *data ,const char *key ,ini_type type ,void *val_p ,int val );

/*	iniRmvKey
  	data(ini_data*)Key폜iɁj
    
    @param: ini_data *data
    Ώۂini_dataϐ
    
    @param: ini_data *data
    폜ΏۂKey
	
    @return: true = Afalse = siKey݂Ȃ)
 */
bool iniRmvKey( ini_data *data ,const char *key );



/*	iniLoad
  	t@Cݒ擾
  	
  	data(ini_data*)Ŏw肳ĂeKeỹf[^^ɉĒl擾
    
    @param: const char *path
    ǂݍރt@C
    
    @param: ini_data *data
    Ώۂini_dataϐ
    
    @param: libini_cbl callback_load
    l^KeyR[obN֐
    ĂKeyɉValueϊ
    t@CɑΏKey̋LqȂΌĂяoȂ
    
    [R[obN֐֑Ăl]
    const char *key		= t@C擾Key
    char *val			= t@C擾Value
    void *opt			= R[obN֓nꂽf[^iiniLoadŎw肵callback_opt)
    𐳂oǂAbool^Ŗ߂lƂĕԋp
	
    @param: void *callback_opt
    R[obN֐֓nf[^
    R[obNwȂNULL
	
    @return: iniAddKeyŒǉKeyƔׂāAۂɃt@C擾oݒ萔
	
    0 = t@C݂ȂA̐ݒsAȊO = 炩̐ݒ肪擾oĂ
   	
  	Key/Value̎n܂EI͑Õ^u(\t)Ap/SpXy[XOʒuŎ
  	@啶͋ʂɔr܂iINI_TYPE_STR̂ݎgp҂Ŕfj
  	@
  	@llKeyiniAddKeyŃ^Cv(8i/10i/16i)w肵Ȃ
  	@l擾Ȃ̂Œ
 */
int iniLoad( const char *path ,ini_data *data ,libini_cbl callback_load ,void *callback_opt );

/*	iniSave
	t@C֐ݒۑ
	
  	data(ini_data*)Ŏw肳ĂKey/Value
  	ꂼ̃f[^^ɉăt@C֕ۑ
    
    @param: const char *path
    ۑt@C
    
    @param: ini_data *data
    Ώۂini_dataϐ
    
    @param: libini_cbs callback_save
    l^KeyR[obN֐
    ĂKeyɉăt@C֏ޕԋp
    t@CɑΏKey̋LqȂΌĂяoȂ
	
	[R[obN֐֑Ăl]
    const char *key		= t@C֕ۑKey
    void *opt			= R[obN֓nꂽf[^iiniSaveŎw肵callback_opt)
	
    @param: void *callback_opt
    R[obN֐֓nf[^
    R[obNwȂNULL
	
    @return: true = Afalse = si󂫗eʕsŃt@C߂ȂA̐ݒsj
   	
   	ۑt@Cɑ݂ꍇ
   	@ΏۊO̕ۂ܂܏㏑̂ŖȂ
   	@
  	@llKeyiniAddKeyŃ^Cv(8i/10i/16i)w肵Ȃ
  	@]ԂŕۑȂ̂Œ
*/
bool iniSave( const char *path ,ini_data *data ,libini_cbs callback_save ,void *callback_opt );


/*
	iniCounterPbrk
	(src)̐擪當Q(search)܂܂Ȃŏ̈ʒuԂ
	
    @param: const char * src
    ̕
    
    @param: const char *search
    Ώۂ̕
	
	@return: Q܂܂Ȃŏ̈ʒui擪j
	NULL = ݂Ȃ
*/
char* iniCounterPbrk( const char *src, const char *search );

/*
	iniCounterReversePbrk
	(src)̖當Q(search)܂܂Ȃŏ̈ʒuԂ
	
    @param: const char * src
    ̕
    
    @param: const char *search
    Ώۂ̕
	
	@return: Q܂܂Ȃŏ̈ʒuij
	NULL = ݂Ȃ
*/
char* iniCounterReversePbrk( const char *src, const char *search );

/*
	iniGetArraySize
	data->sizedata->pairz̗vf擾
	(data->pairz̐ݒ󋵂`FbNj
	
	@param: ini_data *data
    Ώۂini_dataϐ
	
	@return: data->pairz̗vf
	data->size̒lُȏꍇ0
*/
int iniGetArraySize( ini_data *data );


#ifdef __cplusplus
}
#endif

#endif
